## dolfin 0.9.7

=== SConstruct ===
# -*- coding: utf-8 -*-

import os, os.path, sys
import warnings
import pickle

from distutils import sysconfig

# Make sure that we have a good scons-version
EnsureSConsVersion(0, 98, 5)

# Import the local 'scons'
sys.path.insert(0, os.path.abspath(os.path.join("scons", "simula-scons")))
print os.path.abspath(os.path.join("scons", "simula-scons"))
import simula_scons as scons

# Import local exceptions
from simula_scons.Errors import PkgconfigError, PkgconfigMissing

# Create a SCons Environment based on the main os environment
env = scons.ExtendedEnvironment(ENV=os.environ)

# Add ARGUMENTS to SCons environment
env.ARGUMENTS = ARGUMENTS

# Set a projectname. Used in some places, like pkg-config generator
env["projectname"] = "dolfin"

# Set version
env["PACKAGE_VERSION"] = "0.9.7"

scons.setDefaultEnv(env)

# Specify a file where SCons store file signatures, used to figure out what is
# changed. We store it in the 'scons' subdirectory to avoid mixing signatures
# with the files in this project.
project_sconsignfile = os.path.abspath(os.path.join("scons", ".sconsign"))
env.SConsignFile(project_sconsignfile)

# -----------------------------------------------------------------------------
# Command line option handling
# -----------------------------------------------------------------------------

DefaultPackages = ""

if env["PLATFORM"].startswith("win"):
  default_prefix = r"c:\local"
else:
  default_prefix = os.path.join(os.path.sep,"usr","local")

# Set a global path_validator
path_validator = PathVariable.PathAccept

# Build the commandline options for SCons:
options = [
    # configurable options for installation:
    PathVariable("prefix", "Installation prefix", default_prefix,
                 path_validator),
    PathVariable("DESTDIR",
                 "Prepend DESTDIR to each installed target file", None,
                 path_validator),
    PathVariable("binDir", "Binary installation directory",
                 os.path.join("$prefix","bin"), path_validator),
    PathVariable("manDir", "Manual page installation directory",
                 os.path.join("$prefix", "share", "man"), path_validator),
    PathVariable("libDir", "Library installation directory",
                 os.path.join("$prefix","lib"), path_validator),
    PathVariable("pkgConfDir", "Directory for installation of pkg-config files",
                 os.path.join("$prefix","lib","pkgconfig"), path_validator),
    PathVariable("includeDir", "C/C++ header installation directory",
                 os.path.join("$prefix","include"), path_validator),
    PathVariable("pythonModuleDir", "Python module installation directory",
                 scons.defaultPythonLib(prefix="$prefix"),
                 path_validator),
    PathVariable("pythonExtDir", "Python extension module installation directory",
                 scons.defaultPythonLib(prefix="$prefix", plat_specific=True),
                 path_validator),
    # configurable options for how we want to build:
    BoolVariable("enableDebug", "Build with debug information", 1),
    BoolVariable("enableExtraDebug", "Build with extra debug information (no -O2)", 0),
    BoolVariable("enableDebugUblas", "Add some extra Ublas debug information", 0),
    BoolVariable("enableOptimize", "Compile with optimization", 0),
    BoolVariable("enableDocs", "Build documentation", 0),
    BoolVariable("enableDemos", "Build demos", 0),
    BoolVariable("enableTests", "Build tests", 0),
    BoolVariable("enableBenchmarks", "Build benchmark programs", 0),
    BoolVariable("enableCodeCoverage", "Enable code coverage", 0),
    BoolVariable("enableResolveCompiler", "Run tests to verify compiler", 1),
    # Enable or disable external packages.
    # These will also be listed in scons.cfg files, but if they are
    # disabled here, that will override scons.cfg. Remark that unless the
    # module is listed as OptDependencies in scons.cfg, the whole module
    # will be turned off.
    BoolVariable("enableMpi", "Compile with support for MPI", "yes"),
    BoolVariable("enablePetsc", "Compile with support for PETSc linear algebra", "yes"),
    BoolVariable("enableSlepc", "Compile with support for SLEPc", "yes"),
    BoolVariable("enableScotch", "Compile with support for SCOTCH graph partitioning", "yes"),
    BoolVariable("enableUmfpack", "Compile with support for UMFPACK", "yes"),
    BoolVariable("enableTrilinos", "Compile with support for Trilinos", "yes"),
    BoolVariable("enableCholmod", "Compile with support for CHOLMOD", "yes"),
    BoolVariable("enableMtl4", "Compile with support for MTL4", "yes"),
    BoolVariable("enableParmetis", "Compile with support for ParMETIS", "yes"),
    BoolVariable("enableGmp", "Compile with support for GMP", "no"),
    BoolVariable("enableZlib", "Compile with support for zlib", "yes"),
    BoolVariable("enableCgal", "Compile with support for CGAL", "yes"),
    BoolVariable("enableLapack", "Compile with support for LAPACK", "yes"),
    BoolVariable("enablePython", "Compile the Python wrappers", "yes"),
    BoolVariable("enablePydolfin", "Compile the Python wrappers of DOLFIN *deprecated*", "yes"),
    # some of the above may need extra options (like petscDir), should we
    # try to get that from pkg-config?
    # It may be neccessary to specify the installation path to the above packages.
    # One can either use the options below (with<Package>Dir) or define the
    # <PACKAGE>_DIR environment variable.
    PathVariable("withPetscDir", "Specify path to PETSc", None, path_validator),
    PathVariable("withSlepcDir", "Specify path to SLEPc", None, path_validator),
    PathVariable("withScotchDir", "Specify path to SCOTCH", None, path_validator),
    PathVariable("withUmfpackDir", "Specify path to UMFPACK", None, path_validator),
    PathVariable("withTrilinosDir", "Specify path to Trilinos", None, path_validator),
    PathVariable("withCholmodDir", "Specify path to CHOLMOD", None, path_validator),
    PathVariable("withMtl4Dir", "Specify path to MTL4", None, path_validator),
    PathVariable("withParmetisDir", "Specify path to ParMETIS", None, path_validator),
    PathVariable("withGmpDir", "Specify path to GMP", None, path_validator),
    PathVariable("withBoostDir", "Specify path to Boost", None, path_validator),
    PathVariable("withLibxml2Dir", "Specify path to libXML2", None, path_validator),
    PathVariable("withZlibDir", "Specify path to zlib", None, path_validator),
    PathVariable("withCgalDir", "Specify path to CGAL", None, path_validator),
    PathVariable("withLapackDir", "Specify path to LAPACK", None, path_validator),
    PathVariable("withBlasDir", "Specify path to BLAS", None, path_validator),
    #
    # a few more options originally from PyCC:
    #BoolVariable("autoFetch", "Automatically fetch datafiles from (password protected) SSH repository", 0),
    BoolVariable("cacheOptions", "Cache command-line options for later invocations", 1),
    BoolVariable("veryClean", "Remove the sconsign file during clean, must be set during regular build", 0),
    # maybe we should do this more cleverly. The default in dolfin now is
    # to use mpicxx if that is available...:
    #("CXX", "Set C++ compiler", scons.defaultCxxCompiler()),
    #("FORTRAN", "Set FORTRAN compiler",scons.defaultFortranCompiler()),
    ("customCxxFlags", "Customize compilation of C++ code", ""),
    ("customLinkFlags", "Customize linking of C++ code", ""),
    #("data", "Parameter to the 'fetch' target: comma-delimited list of directories/files to fetch, \
    #        relative to the `data' directory. An empty value means that everything will be fetched.", ""),
    #("sshUser", "Specify the user for the SSH connection used to retrieve data files", ""),
    #('usePackages','Override or add dependency packages, separate with comma', ""),
    #('customDefaultPackages','Override the default set of packages (%r), separate package names with commas' % (DefaultPackages,)),
    ("SSLOG", "Set Simula scons log file", os.path.join(os.getcwd(),"scons","simula_scons.log")),
    ("withPetscArch", "The architecture PETSc is configured with", None),
    ]


# Option enablePydolfin is now deprecated
if ARGUMENTS.has_key("enablePydolfin"):
  msg = "Option 'enablePydolfin' is deprecated and will be removed in " \
        "the future. Please use the option 'enablePython' instead to " \
        "enable/disable compiling of Python wrappers."
  warnings.warn(msg, DeprecationWarning)
  if not ARGUMENTS.has_key("enablePython"):
    ARGUMENTS["enablePython"] = ARGUMENTS["enablePydolfin"]
  del ARGUMENTS["enablePydolfin"]

config_cache = os.path.join('scons', 'config.cache')
if not "configure" in COMMAND_LINE_TARGETS and not env.GetOption('help'):
  # Try to open the pickled configuration cache under scons/config.cache
  try:
    f = open(config_cache, 'r')
    up = pickle.Unpickler(f)
    env_cache, modules, configuredPackages = up.load()
    for key, value in env_cache.items():
      env[key] = value
  except IOError:
      print """---------------------------------------------------------
No configuration found. Please run

    scons configure

before building DOLFIN. To view a complete list of
available configuration options, run

    scons configure --help or -h

For SCons specific options, run

    scons --help-options or -H

---------------------------------------------------------"""
      Exit(1)

# Set up basic data dicitionary
buildDataHash = {"shlibs": [], "extModules": [], "docs": [], "headers": [],
                 "pythonModules": [], "pythonScripts": [], "pkgconfig": [],
                 "pythonPackageDirs": [], "data": [], "tests": [], "progs": [],
                 "demos": [], "dolfin_header": "", "swigfiles": [],
                 "benchmarks": []}

if "configure" in COMMAND_LINE_TARGETS:
  # This Configure class handles both command-line options (which are merged
  # into the environment) and autoconf-style tests. A special feature is that it
  # remembers configuration parameters (options and results from tests) between
  # invocations so that they are re-used when cleaning after a previous build.
  configure = scons.Configure(env, ARGUMENTS, options)

  # Open log file for writing
  scons.logOpen(env)
  scons.log("=================== %s log ===================" % \
            env["projectname"])
  scons.logDate()

  # Writing the simula_scons used to the log:
  scons.log("Using simula_scons from: %s" % scons.__file__)

  # Notify the user about that options from scons/options.cache are being used:
  if not env.GetOption("clean"):
    try:
      optsCache = os.path.abspath(os.path.join("scons", "options.cache"))
      lines = file(optsCache).readlines()
      if lines:
        print "Using options from %s" % optsCache
      # FIXME: this can be removed when option enablePydolfin is removed
      new_lines = []
      for line in lines:
        if line.startswith("enablePydolfin"):
          if not "enablePython" in lines:
            env["enablePython"] = eval(line.split('=')[1])
            new_lines.append("enablePython = %s\n" % env["enablePython"])
        else:
          new_lines.append(line)
      if new_lines != lines:
        file(optsCache, 'w').writelines(new_lines)
    except IOError, msg:
      pass

  # Set default compiler and linker flags (defining CXXFLAGS/LINKFLAGS
  # will override this)
  env['CXXFLAGS'] = os.environ.get("CXXFLAGS", "-Wall -pipe -ansi")
  env["LINKFLAGS"] = os.environ.get("LINKFLAGS", "")  # FIXME: "" OK as default?

  # Default FORTRAN flags
  #env["SHFORTRANFLAGS"] = "-Wall -pipe -fPIC"

  # If Debug is enabled, add -g:

  if not env["enableDebugUblas"]:
    env.Append(CXXFLAGS=" -BOOST_UBLAS_NDEBUG")

  # if Optimization is requested, use -O3
  if env["enableOptimize"]:
    env.Append(CXXFLAGS=" -O3")
  elif env["enableExtraDebug"]:
    env.Append(CXXFLAGS=" -DDEBUG -g -Werror")
  elif env["enableDebug"]:
    env.Append(CXXFLAGS=" -DDEBUG -g -O2  -Werror")
  else:
