## dolfin 0.9.8

=== SConstruct ===
--- 
+++ 
@@ -27,7 +27,7 @@
 env["projectname"] = "dolfin"
 
 # Set version
-env["PACKAGE_VERSION"] = "0.9.7"
+env["PACKAGE_VERSION"] = "0.9.8"
 
 scons.setDefaultEnv(env)
 
@@ -105,7 +105,6 @@
     BoolVariable("enableCgal", "Compile with support for CGAL", "yes"),
     BoolVariable("enableLapack", "Compile with support for LAPACK", "yes"),
     BoolVariable("enablePython", "Compile the Python wrappers", "yes"),
-    BoolVariable("enablePydolfin", "Compile the Python wrappers of DOLFIN *deprecated*", "yes"),
     # some of the above may need extra options (like petscDir), should we
     # try to get that from pkg-config?
     # It may be neccessary to specify the installation path to the above packages.
@@ -126,6 +125,7 @@
     PathVariable("withCgalDir", "Specify path to CGAL", None, path_validator),
     PathVariable("withLapackDir", "Specify path to LAPACK", None, path_validator),
     PathVariable("withBlasDir", "Specify path to BLAS", None, path_validator),
+    PathVariable("withArmadilloDir", "Specify path to Armadillo", None, path_validator),
     #
     # a few more options originally from PyCC:
     #BoolVariable("autoFetch", "Automatically fetch datafiles from (password protected) SSH repository", 0),
@@ -144,18 +144,15 @@
     #('customDefaultPackages','Override the default set of packages (%r), separate package names with commas' % (DefaultPackages,)),
     ("SSLOG", "Set Simula scons log file", os.path.join(os.getcwd(),"scons","simula_scons.log")),
     ("withPetscArch", "The architecture PETSc is configured with", None),
+    ("withBlasLapackLib", "Indicate the library(s) containing BLAS and LAPACK", None),
+    ("withMpiCompiler", "Specify the MPI compiler", ""),
     ]
 
-
-# Option enablePydolfin is now deprecated
-if ARGUMENTS.has_key("enablePydolfin"):
-  msg = "Option 'enablePydolfin' is deprecated and will be removed in " \
-        "the future. Please use the option 'enablePython' instead to " \
-        "enable/disable compiling of Python wrappers."
-  warnings.warn(msg, DeprecationWarning)
-  if not ARGUMENTS.has_key("enablePython"):
-    ARGUMENTS["enablePython"] = ARGUMENTS["enablePydolfin"]
-  del ARGUMENTS["enablePydolfin"]
+if ARGUMENTS.has_key("withBlasLapackLib") and \
+       not ARGUMENTS.has_key("withLapackDir"):
+  print "*** When using the withBlasLapackLib option you must also use " \
+        "withLapackDir."
+  Exit(1)
 
 config_cache = os.path.join('scons', 'config.cache')
 if not "configure" in COMMAND_LINE_TARGETS and not env.GetOption('help'):
@@ -214,17 +211,6 @@
       lines = file(optsCache).readlines()
       if lines:
         print "Using options from %s" % optsCache
-      # FIXME: this can be removed when option enablePydolfin is removed
-      new_lines = []
-      for line in lines:
-        if line.startswith("enablePydolfin"):
-          if not "enablePython" in lines:
-            env["enablePython"] = eval(line.split('=')[1])
-            new_lines.append("enablePython = %s\n" % env["enablePython"])
-        else:
-          new_lines.append(line)
-      if new_lines != lines:
-        file(optsCache, 'w').writelines(new_lines)
     except IOError, msg:
       pass
 
@@ -249,3 +235,19 @@
   elif env["enableDebug"]:
     env.Append(CXXFLAGS=" -DDEBUG -g -O2  -Werror")
   else:
+    # FIXME: why are we optimizing when enableOptimize is False?
+    env.Append(CXXFLAGS=" -O2")
+
+  # Not sure we need this - but lets leave it for completeness sake - if people
+  # use if for PyCC, and know that dolfin use the same system, they will expect
+  # it to be here. We should probably discuss whether that is a good argument or
+  # not.
+  # Append whatever custom flags given
+  if env["customCxxFlags"]:
+    env.Append(CXXFLAGS=" " + env["customCxxFlags"])
+
+  # Append custom linker flags
+  if env["customLinkFlags"]:
+    env.Append(LINKFLAGS=" " + env["customLinkFlags"])
+
+  # Determine which compiler to be used:
