=== demo/pde/cahn-hilliard/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', ['main.cpp', 'CahnHilliard2D.cpp', 'CahnHilliard3D.cpp'])
