=== debian/changelog ===
dolfin (0.9.8-3) unstable; urgency=low

  * Disable Trilinos on non-supported platforms (closes: #590100).

 -- Johannes Ring <johannr@simula.no>  Wed, 04 Aug 2010 16:47:38 +0200

dolfin (0.9.8-2) unstable; urgency=low

  * Fix generation of pkg-config file dolfin.pc.

 -- Johannes Ring <johannr@simula.no>  Sun, 04 Jul 2010 20:41:45 +0200

dolfin (0.9.8-1) unstable; urgency=low

  * New upstream release.
  * debian/control: 
    - Update version for python-ufc in Build-Depends field.
    - Update version for python-ufl in Depends field for binary package
      libdolfin0-dev.
    - Update version for ufc, python-ffc, and python-viper in Depends
      field for binary package libdolfin0-dev.
    - Add libarmadillo-dev to Build-Depends and Depends for binary
      package libdolfin0-dev.
  * Allow building against either version 3.0.0 or 3.1 of PETSc. 
  * Remove patches (added upstream).
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update debian/copyright and debian/copyright_hints.
  * Enable Trilinos support.

 -- Johannes Ring <johannr@simula.no>  Fri, 02 Jul 2010 13:24:21 +0200

dolfin (0.9.7-5) unstable; urgency=low

  * Add patch from upstream to detect and build with SCOTCH.

 -- Johannes Ring <johannr@simula.no>  Mon, 14 Jun 2010 13:15:04 +0200

dolfin (0.9.7-4) unstable; urgency=low

  * Add support for PETSc 3.1 (closes: #583419).
  * Minor fix in Vcs fields in debian/control.

 -- Johannes Ring <johannr@simula.no>  Mon, 07 Jun 2010 09:25:13 +0200

dolfin (0.9.7-3) unstable; urgency=low

  * debian/rules: Remove bashism (closes: #581470).

 -- Johannes Ring <johannr@simula.no>  Thu, 20 May 2010 10:27:06 +0200

dolfin (0.9.7-2) unstable; urgency=low

  * Package moved from pkg-scicomp to Debian Science.
  * Enable building for multiple Python versions.
  * debian/control:
    - Replace python-dev with python-all-dev in Build-Depends.
    - Update version dependencies for python-ufc, ufc, python-ffc, and
      python-viper (closes: #571780).
    - Replace libscotch-dev with libptscotch-dev in Build-Depends and in
      Depends for binary package libdolfin0-dev.
  * Add configure target to cdbs tweaks for scons.
  * Rename binary package python-pydolfin0 to python-dolfin.

 -- Johannes Ring <johannr@simula.no>  Tue, 27 Apr 2010 17:21:22 +0200

dolfin (0.9.7-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Add pkg-config to Build-Depends and Depends in
    binary package libdolfin0-dev.
  * Do not build with GTS (support was removed upstream).
  * Keep debian/copyright and debian/copyright_hints up to date.

 -- Johannes Ring <johannr@simula.no>  Thu, 18 Feb 2010 00:40:38 +0100

dolfin (0.9.6-2) unstable; urgency=low

  * Disable support for Trilinos for now.

 -- Johannes Ring <johannr@simula.no>  Sat, 13 Feb 2010 09:55:48 +0100

dolfin (0.9.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add libtrilinos-dev to Build-Depends and Depends for binary
      package libdolfin0-dev.
    - Add python-pytrilinos to Build-Depends and Depends for binary
      package python-pydolfin0.
    - Bump Standards-Version to 3.8.4 (no changes needed).
  * debian/rules:
    - Enable building with Trilinos.
    - Remove some old lintian fixes.
    - Fix problem when generating pkg-config dolfin.pc in
      install/libdolfin0-dev target.
  * debian/copyright: Keep up-to-date with new and removed files.

 -- Johannes Ring <johannr@simula.no>  Fri, 12 Feb 2010 10:27:02 +0100

dolfin (0.9.5-1) unstable; urgency=low

  * New upstream release. This release simplifies the use of Constants
    and Expressions in both the C++ and Python interfaces, with the
    automatic selection of function spaces from Python. Support for
    computing eigenvalues of symmetric matrices has been improved and a
    number of small bugs have been fixed.
  * debian/watch: Update download URL.
  * debian/copyright: Update for new and removed files.
  * debian/rules: 
    - Include new adaptivity demos in dolfin-doc package.
    - Disable ParMETIS and MTL4 explicitly.
  * Add debian/dolfin-doc.doc-base for DOLFIN user manual.
  * debian/control: Slight modifications in package descriptions.
  * debian/python-pydolfin0.install: Allow both site-packages and
    dist-packages.

 -- Johannes Ring <johannr@simula.no>  Thu, 10 Dec 2009 11:53:04 +0100

dolfin (0.9.4-1) unstable; urgency=low

  * New upstream release. This version cleans up the design of the
    function class by adding a new abstraction for user-defined
    functions called Expression. A number of minor bugfixes and
    improvements have also been made.
  * debian/watch: Update for new flat directory structure.
  * Update debian/copyright.
  * debian/rules: Use explicit paths to PETSc 3.0.0 and SLEPc 3.0.0.

 -- Johannes Ring <johannr@simula.no>  Mon, 12 Oct 2009 14:13:18 +0200

dolfin (0.9.3-1) unstable; urgency=low

  * New upstream release. This version provides many new features,
    improvements and bug fixes, including improved XML file handling,
    improved Python support and compressed VTK file output. Experimental
    parallel assembly and solve is now available, with fully distributed
    meshes, parallel mesh partitioning and parallel IO.
  * debian/control:
    - Add DM-Upload-Allowed: yes.
    - Bump debhelper version to 7.
    - Bump Standards-Version to 3.8.3 (no changes needed).
    - Add libboost-program-options-dev and libboost-filesystem-dev to
      Build-Depends and to Depends for binary package libdolfin0-dev.
  * debian/rules:
    - Update for new 3 step build process.
    - Build documentation.
  * Update debian/copyright.
  * Remove old patches (now included upstream).
  * Remove (temporary) support for Trilinos because of #529807.

 -- Johannes Ring <johannr@simula.no>  Mon, 28 Sep 2009 09:21:05 +0200

dolfin (0.9.2-2) unstable; urgency=low

  * debian/control: 
    - add build-dependency on libtrilinos-dev and
      libboost-serialization-dev (closes: #540118). 

