=== debian/watch ===
version=3
http://launchpad.net/dolfin/+download http://launchpad.net/dolfin/.*/dolfin-(.*)\.tar\.gz
